# /* **************************************************************************
#  *                                                                          *
#  *     (C) Copyright Paul Mensonides 2002.
#  *     Distributed under the Boost Software License, Version 1.0. (See
#  *     accompanying file LICENSE_1_0.txt or copy at
#  *     http://www.boost.org/LICENSE_1_0.txt)
#  *                                                                          *
#  ************************************************************************** */
#
# /* See http://www.boost.org for most recent version. */
#
#
#ifndef __yas__detail__preprocessor__auto_rec_hpp
#define __yas__detail__preprocessor__auto_rec_hpp
#
# include <yas/detail/preprocessor/config.hpp>
# include <yas/detail/preprocessor/iif.hpp>
#
# /* YAS_PP_AUTO_REC */
#
# define YAS_PP_AUTO_REC(pred, n) YAS_PP_NODE_ENTRY_ ## n(pred)
#
# define YAS_PP_NODE_ENTRY_256(p) YAS_PP_NODE_128(p)(p)(p)(p)(p)(p)(p)(p)
# define YAS_PP_NODE_ENTRY_128(p) YAS_PP_NODE_64(p)(p)(p)(p)(p)(p)(p)
# define YAS_PP_NODE_ENTRY_64(p) YAS_PP_NODE_32(p)(p)(p)(p)(p)(p)
# define YAS_PP_NODE_ENTRY_32(p) YAS_PP_NODE_16(p)(p)(p)(p)(p)
# define YAS_PP_NODE_ENTRY_16(p) YAS_PP_NODE_8(p)(p)(p)(p)
# define YAS_PP_NODE_ENTRY_8(p) YAS_PP_NODE_4(p)(p)(p)
# define YAS_PP_NODE_ENTRY_4(p) YAS_PP_NODE_2(p)(p)
# define YAS_PP_NODE_ENTRY_2(p) YAS_PP_NODE_1(p)
#
# define YAS_PP_NODE_128(p) YAS_PP_IIF(p(128), YAS_PP_NODE_64, YAS_PP_NODE_192)
#    define YAS_PP_NODE_64(p) YAS_PP_IIF(p(64), YAS_PP_NODE_32, YAS_PP_NODE_96)
#        define YAS_PP_NODE_32(p) YAS_PP_IIF(p(32), YAS_PP_NODE_16, YAS_PP_NODE_48)
#            define YAS_PP_NODE_16(p) YAS_PP_IIF(p(16), YAS_PP_NODE_8, YAS_PP_NODE_24)
#                define YAS_PP_NODE_8(p) YAS_PP_IIF(p(8), YAS_PP_NODE_4, YAS_PP_NODE_12)
#                    define YAS_PP_NODE_4(p) YAS_PP_IIF(p(4), YAS_PP_NODE_2, YAS_PP_NODE_6)
#                        define YAS_PP_NODE_2(p) YAS_PP_IIF(p(2), YAS_PP_NODE_1, YAS_PP_NODE_3)
#                            define YAS_PP_NODE_1(p) YAS_PP_IIF(p(1), 1, 2)
#                            define YAS_PP_NODE_3(p) YAS_PP_IIF(p(3), 3, 4)
#                        define YAS_PP_NODE_6(p) YAS_PP_IIF(p(6), YAS_PP_NODE_5, YAS_PP_NODE_7)
#                            define YAS_PP_NODE_5(p) YAS_PP_IIF(p(5), 5, 6)
#                            define YAS_PP_NODE_7(p) YAS_PP_IIF(p(7), 7, 8)
#                    define YAS_PP_NODE_12(p) YAS_PP_IIF(p(12), YAS_PP_NODE_10, YAS_PP_NODE_14)
#                        define YAS_PP_NODE_10(p) YAS_PP_IIF(p(10), YAS_PP_NODE_9, YAS_PP_NODE_11)
#                            define YAS_PP_NODE_9(p) YAS_PP_IIF(p(9), 9, 10)
#                            define YAS_PP_NODE_11(p) YAS_PP_IIF(p(11), 11, 12)
#                        define YAS_PP_NODE_14(p) YAS_PP_IIF(p(14), YAS_PP_NODE_13, YAS_PP_NODE_15)
#                            define YAS_PP_NODE_13(p) YAS_PP_IIF(p(13), 13, 14)
#                            define YAS_PP_NODE_15(p) YAS_PP_IIF(p(15), 15, 16)
#                define YAS_PP_NODE_24(p) YAS_PP_IIF(p(24), YAS_PP_NODE_20, YAS_PP_NODE_28)
#                    define YAS_PP_NODE_20(p) YAS_PP_IIF(p(20), YAS_PP_NODE_18, YAS_PP_NODE_22)
#                        define YAS_PP_NODE_18(p) YAS_PP_IIF(p(18), YAS_PP_NODE_17, YAS_PP_NODE_19)
#                            define YAS_PP_NODE_17(p) YAS_PP_IIF(p(17), 17, 18)
#                            define YAS_PP_NODE_19(p) YAS_PP_IIF(p(19), 19, 20)
#                        define YAS_PP_NODE_22(p) YAS_PP_IIF(p(22), YAS_PP_NODE_21, YAS_PP_NODE_23)
#                            define YAS_PP_NODE_21(p) YAS_PP_IIF(p(21), 21, 22)
#                            define YAS_PP_NODE_23(p) YAS_PP_IIF(p(23), 23, 24)
#                    define YAS_PP_NODE_28(p) YAS_PP_IIF(p(28), YAS_PP_NODE_26, YAS_PP_NODE_30)
#                        define YAS_PP_NODE_26(p) YAS_PP_IIF(p(26), YAS_PP_NODE_25, YAS_PP_NODE_27)
#                            define YAS_PP_NODE_25(p) YAS_PP_IIF(p(25), 25, 26)
#                            define YAS_PP_NODE_27(p) YAS_PP_IIF(p(27), 27, 28)
#                        define YAS_PP_NODE_30(p) YAS_PP_IIF(p(30), YAS_PP_NODE_29, YAS_PP_NODE_31)
#                            define YAS_PP_NODE_29(p) YAS_PP_IIF(p(29), 29, 30)
#                            define YAS_PP_NODE_31(p) YAS_PP_IIF(p(31), 31, 32)
#            define YAS_PP_NODE_48(p) YAS_PP_IIF(p(48), YAS_PP_NODE_40, YAS_PP_NODE_56)
#                define YAS_PP_NODE_40(p) YAS_PP_IIF(p(40), YAS_PP_NODE_36, YAS_PP_NODE_44)
#                    define YAS_PP_NODE_36(p) YAS_PP_IIF(p(36), YAS_PP_NODE_34, YAS_PP_NODE_38)
#                        define YAS_PP_NODE_34(p) YAS_PP_IIF(p(34), YAS_PP_NODE_33, YAS_PP_NODE_35)
#                            define YAS_PP_NODE_33(p) YAS_PP_IIF(p(33), 33, 34)
#                            define YAS_PP_NODE_35(p) YAS_PP_IIF(p(35), 35, 36)
#                        define YAS_PP_NODE_38(p) YAS_PP_IIF(p(38), YAS_PP_NODE_37, YAS_PP_NODE_39)
#                            define YAS_PP_NODE_37(p) YAS_PP_IIF(p(37), 37, 38)
#                            define YAS_PP_NODE_39(p) YAS_PP_IIF(p(39), 39, 40)
#                    define YAS_PP_NODE_44(p) YAS_PP_IIF(p(44), YAS_PP_NODE_42, YAS_PP_NODE_46)
#                        define YAS_PP_NODE_42(p) YAS_PP_IIF(p(42), YAS_PP_NODE_41, YAS_PP_NODE_43)
#                            define YAS_PP_NODE_41(p) YAS_PP_IIF(p(41), 41, 42)
#                            define YAS_PP_NODE_43(p) YAS_PP_IIF(p(43), 43, 44)
#                        define YAS_PP_NODE_46(p) YAS_PP_IIF(p(46), YAS_PP_NODE_45, YAS_PP_NODE_47)
#                            define YAS_PP_NODE_45(p) YAS_PP_IIF(p(45), 45, 46)
#                            define YAS_PP_NODE_47(p) YAS_PP_IIF(p(47), 47, 48)
#                define YAS_PP_NODE_56(p) YAS_PP_IIF(p(56), YAS_PP_NODE_52, YAS_PP_NODE_60)
#                    define YAS_PP_NODE_52(p) YAS_PP_IIF(p(52), YAS_PP_NODE_50, YAS_PP_NODE_54)
#                        define YAS_PP_NODE_50(p) YAS_PP_IIF(p(50), YAS_PP_NODE_49, YAS_PP_NODE_51)
#                            define YAS_PP_NODE_49(p) YAS_PP_IIF(p(49), 49, 50)
#                            define YAS_PP_NODE_51(p) YAS_PP_IIF(p(51), 51, 52)
#                        define YAS_PP_NODE_54(p) YAS_PP_IIF(p(54), YAS_PP_NODE_53, YAS_PP_NODE_55)
#                            define YAS_PP_NODE_53(p) YAS_PP_IIF(p(53), 53, 54)
#                            define YAS_PP_NODE_55(p) YAS_PP_IIF(p(55), 55, 56)
#                    define YAS_PP_NODE_60(p) YAS_PP_IIF(p(60), YAS_PP_NODE_58, YAS_PP_NODE_62)
#                        define YAS_PP_NODE_58(p) YAS_PP_IIF(p(58), YAS_PP_NODE_57, YAS_PP_NODE_59)
#                            define YAS_PP_NODE_57(p) YAS_PP_IIF(p(57), 57, 58)
#                            define YAS_PP_NODE_59(p) YAS_PP_IIF(p(59), 59, 60)
#                        define YAS_PP_NODE_62(p) YAS_PP_IIF(p(62), YAS_PP_NODE_61, YAS_PP_NODE_63)
#                            define YAS_PP_NODE_61(p) YAS_PP_IIF(p(61), 61, 62)
#                            define YAS_PP_NODE_63(p) YAS_PP_IIF(p(63), 63, 64)
#        define YAS_PP_NODE_96(p) YAS_PP_IIF(p(96), YAS_PP_NODE_80, YAS_PP_NODE_112)
#            define YAS_PP_NODE_80(p) YAS_PP_IIF(p(80), YAS_PP_NODE_72, YAS_PP_NODE_88)
#                define YAS_PP_NODE_72(p) YAS_PP_IIF(p(72), YAS_PP_NODE_68, YAS_PP_NODE_76)
#                    define YAS_PP_NODE_68(p) YAS_PP_IIF(p(68), YAS_PP_NODE_66, YAS_PP_NODE_70)
#                        define YAS_PP_NODE_66(p) YAS_PP_IIF(p(66), YAS_PP_NODE_65, YAS_PP_NODE_67)
#                            define YAS_PP_NODE_65(p) YAS_PP_IIF(p(65), 65, 66)
#                            define YAS_PP_NODE_67(p) YAS_PP_IIF(p(67), 67, 68)
#                        define YAS_PP_NODE_70(p) YAS_PP_IIF(p(70), YAS_PP_NODE_69, YAS_PP_NODE_71)
#                            define YAS_PP_NODE_69(p) YAS_PP_IIF(p(69), 69, 70)
#                            define YAS_PP_NODE_71(p) YAS_PP_IIF(p(71), 71, 72)
#                    define YAS_PP_NODE_76(p) YAS_PP_IIF(p(76), YAS_PP_NODE_74, YAS_PP_NODE_78)
#                        define YAS_PP_NODE_74(p) YAS_PP_IIF(p(74), YAS_PP_NODE_73, YAS_PP_NODE_75)
#                            define YAS_PP_NODE_73(p) YAS_PP_IIF(p(73), 73, 74)
#                            define YAS_PP_NODE_75(p) YAS_PP_IIF(p(75), 75, 76)
#                        define YAS_PP_NODE_78(p) YAS_PP_IIF(p(78), YAS_PP_NODE_77, YAS_PP_NODE_79)
#                            define YAS_PP_NODE_77(p) YAS_PP_IIF(p(77), 77, 78)
#                            define YAS_PP_NODE_79(p) YAS_PP_IIF(p(79), 79, 80)
#                define YAS_PP_NODE_88(p) YAS_PP_IIF(p(88), YAS_PP_NODE_84, YAS_PP_NODE_92)
#                    define YAS_PP_NODE_84(p) YAS_PP_IIF(p(84), YAS_PP_NODE_82, YAS_PP_NODE_86)
#                        define YAS_PP_NODE_82(p) YAS_PP_IIF(p(82), YAS_PP_NODE_81, YAS_PP_NODE_83)
#                            define YAS_PP_NODE_81(p) YAS_PP_IIF(p(81), 81, 82)
#                            define YAS_PP_NODE_83(p) YAS_PP_IIF(p(83), 83, 84)
#                        define YAS_PP_NODE_86(p) YAS_PP_IIF(p(86), YAS_PP_NODE_85, YAS_PP_NODE_87)
#                            define YAS_PP_NODE_85(p) YAS_PP_IIF(p(85), 85, 86)
#                            define YAS_PP_NODE_87(p) YAS_PP_IIF(p(87), 87, 88)
#                    define YAS_PP_NODE_92(p) YAS_PP_IIF(p(92), YAS_PP_NODE_90, YAS_PP_NODE_94)
#                        define YAS_PP_NODE_90(p) YAS_PP_IIF(p(90), YAS_PP_NODE_89, YAS_PP_NODE_91)
#                            define YAS_PP_NODE_89(p) YAS_PP_IIF(p(89), 89, 90)
#                            define YAS_PP_NODE_91(p) YAS_PP_IIF(p(91), 91, 92)
#                        define YAS_PP_NODE_94(p) YAS_PP_IIF(p(94), YAS_PP_NODE_93, YAS_PP_NODE_95)
#                            define YAS_PP_NODE_93(p) YAS_PP_IIF(p(93), 93, 94)
#                            define YAS_PP_NODE_95(p) YAS_PP_IIF(p(95), 95, 96)
#            define YAS_PP_NODE_112(p) YAS_PP_IIF(p(112), YAS_PP_NODE_104, YAS_PP_NODE_120)
#                define YAS_PP_NODE_104(p) YAS_PP_IIF(p(104), YAS_PP_NODE_100, YAS_PP_NODE_108)
#                    define YAS_PP_NODE_100(p) YAS_PP_IIF(p(100), YAS_PP_NODE_98, YAS_PP_NODE_102)
#                        define YAS_PP_NODE_98(p) YAS_PP_IIF(p(98), YAS_PP_NODE_97, YAS_PP_NODE_99)
#                            define YAS_PP_NODE_97(p) YAS_PP_IIF(p(97), 97, 98)
#                            define YAS_PP_NODE_99(p) YAS_PP_IIF(p(99), 99, 100)
#                        define YAS_PP_NODE_102(p) YAS_PP_IIF(p(102), YAS_PP_NODE_101, YAS_PP_NODE_103)
#                            define YAS_PP_NODE_101(p) YAS_PP_IIF(p(101), 101, 102)
#                            define YAS_PP_NODE_103(p) YAS_PP_IIF(p(103), 103, 104)
#                    define YAS_PP_NODE_108(p) YAS_PP_IIF(p(108), YAS_PP_NODE_106, YAS_PP_NODE_110)
#                        define YAS_PP_NODE_106(p) YAS_PP_IIF(p(106), YAS_PP_NODE_105, YAS_PP_NODE_107)
#                            define YAS_PP_NODE_105(p) YAS_PP_IIF(p(105), 105, 106)
#                            define YAS_PP_NODE_107(p) YAS_PP_IIF(p(107), 107, 108)
#                        define YAS_PP_NODE_110(p) YAS_PP_IIF(p(110), YAS_PP_NODE_109, YAS_PP_NODE_111)
#                            define YAS_PP_NODE_109(p) YAS_PP_IIF(p(109), 109, 110)
#                            define YAS_PP_NODE_111(p) YAS_PP_IIF(p(111), 111, 112)
#                define YAS_PP_NODE_120(p) YAS_PP_IIF(p(120), YAS_PP_NODE_116, YAS_PP_NODE_124)
#                    define YAS_PP_NODE_116(p) YAS_PP_IIF(p(116), YAS_PP_NODE_114, YAS_PP_NODE_118)
#                        define YAS_PP_NODE_114(p) YAS_PP_IIF(p(114), YAS_PP_NODE_113, YAS_PP_NODE_115)
#                            define YAS_PP_NODE_113(p) YAS_PP_IIF(p(113), 113, 114)
#                            define YAS_PP_NODE_115(p) YAS_PP_IIF(p(115), 115, 116)
#                        define YAS_PP_NODE_118(p) YAS_PP_IIF(p(118), YAS_PP_NODE_117, YAS_PP_NODE_119)
#                            define YAS_PP_NODE_117(p) YAS_PP_IIF(p(117), 117, 118)
#                            define YAS_PP_NODE_119(p) YAS_PP_IIF(p(119), 119, 120)
#                    define YAS_PP_NODE_124(p) YAS_PP_IIF(p(124), YAS_PP_NODE_122, YAS_PP_NODE_126)
#                        define YAS_PP_NODE_122(p) YAS_PP_IIF(p(122), YAS_PP_NODE_121, YAS_PP_NODE_123)
#                            define YAS_PP_NODE_121(p) YAS_PP_IIF(p(121), 121, 122)
#                            define YAS_PP_NODE_123(p) YAS_PP_IIF(p(123), 123, 124)
#                        define YAS_PP_NODE_126(p) YAS_PP_IIF(p(126), YAS_PP_NODE_125, YAS_PP_NODE_127)
#                            define YAS_PP_NODE_125(p) YAS_PP_IIF(p(125), 125, 126)
#                            define YAS_PP_NODE_127(p) YAS_PP_IIF(p(127), 127, 128)
#    define YAS_PP_NODE_192(p) YAS_PP_IIF(p(192), YAS_PP_NODE_160, YAS_PP_NODE_224)
#        define YAS_PP_NODE_160(p) YAS_PP_IIF(p(160), YAS_PP_NODE_144, YAS_PP_NODE_176)
#            define YAS_PP_NODE_144(p) YAS_PP_IIF(p(144), YAS_PP_NODE_136, YAS_PP_NODE_152)
#                define YAS_PP_NODE_136(p) YAS_PP_IIF(p(136), YAS_PP_NODE_132, YAS_PP_NODE_140)
#                    define YAS_PP_NODE_132(p) YAS_PP_IIF(p(132), YAS_PP_NODE_130, YAS_PP_NODE_134)
#                        define YAS_PP_NODE_130(p) YAS_PP_IIF(p(130), YAS_PP_NODE_129, YAS_PP_NODE_131)
#                            define YAS_PP_NODE_129(p) YAS_PP_IIF(p(129), 129, 130)
#                            define YAS_PP_NODE_131(p) YAS_PP_IIF(p(131), 131, 132)
#                        define YAS_PP_NODE_134(p) YAS_PP_IIF(p(134), YAS_PP_NODE_133, YAS_PP_NODE_135)
#                            define YAS_PP_NODE_133(p) YAS_PP_IIF(p(133), 133, 134)
#                            define YAS_PP_NODE_135(p) YAS_PP_IIF(p(135), 135, 136)
#                    define YAS_PP_NODE_140(p) YAS_PP_IIF(p(140), YAS_PP_NODE_138, YAS_PP_NODE_142)
#                        define YAS_PP_NODE_138(p) YAS_PP_IIF(p(138), YAS_PP_NODE_137, YAS_PP_NODE_139)
#                            define YAS_PP_NODE_137(p) YAS_PP_IIF(p(137), 137, 138)
#                            define YAS_PP_NODE_139(p) YAS_PP_IIF(p(139), 139, 140)
#                        define YAS_PP_NODE_142(p) YAS_PP_IIF(p(142), YAS_PP_NODE_141, YAS_PP_NODE_143)
#                            define YAS_PP_NODE_141(p) YAS_PP_IIF(p(141), 141, 142)
#                            define YAS_PP_NODE_143(p) YAS_PP_IIF(p(143), 143, 144)
#                define YAS_PP_NODE_152(p) YAS_PP_IIF(p(152), YAS_PP_NODE_148, YAS_PP_NODE_156)
#                    define YAS_PP_NODE_148(p) YAS_PP_IIF(p(148), YAS_PP_NODE_146, YAS_PP_NODE_150)
#                        define YAS_PP_NODE_146(p) YAS_PP_IIF(p(146), YAS_PP_NODE_145, YAS_PP_NODE_147)
#                            define YAS_PP_NODE_145(p) YAS_PP_IIF(p(145), 145, 146)
#                            define YAS_PP_NODE_147(p) YAS_PP_IIF(p(147), 147, 148)
#                        define YAS_PP_NODE_150(p) YAS_PP_IIF(p(150), YAS_PP_NODE_149, YAS_PP_NODE_151)
#                            define YAS_PP_NODE_149(p) YAS_PP_IIF(p(149), 149, 150)
#                            define YAS_PP_NODE_151(p) YAS_PP_IIF(p(151), 151, 152)
#                    define YAS_PP_NODE_156(p) YAS_PP_IIF(p(156), YAS_PP_NODE_154, YAS_PP_NODE_158)
#                        define YAS_PP_NODE_154(p) YAS_PP_IIF(p(154), YAS_PP_NODE_153, YAS_PP_NODE_155)
#                            define YAS_PP_NODE_153(p) YAS_PP_IIF(p(153), 153, 154)
#                            define YAS_PP_NODE_155(p) YAS_PP_IIF(p(155), 155, 156)
#                        define YAS_PP_NODE_158(p) YAS_PP_IIF(p(158), YAS_PP_NODE_157, YAS_PP_NODE_159)
#                            define YAS_PP_NODE_157(p) YAS_PP_IIF(p(157), 157, 158)
#                            define YAS_PP_NODE_159(p) YAS_PP_IIF(p(159), 159, 160)
#            define YAS_PP_NODE_176(p) YAS_PP_IIF(p(176), YAS_PP_NODE_168, YAS_PP_NODE_184)
#                define YAS_PP_NODE_168(p) YAS_PP_IIF(p(168), YAS_PP_NODE_164, YAS_PP_NODE_172)
#                    define YAS_PP_NODE_164(p) YAS_PP_IIF(p(164), YAS_PP_NODE_162, YAS_PP_NODE_166)
#                        define YAS_PP_NODE_162(p) YAS_PP_IIF(p(162), YAS_PP_NODE_161, YAS_PP_NODE_163)
#                            define YAS_PP_NODE_161(p) YAS_PP_IIF(p(161), 161, 162)
#                            define YAS_PP_NODE_163(p) YAS_PP_IIF(p(163), 163, 164)
#                        define YAS_PP_NODE_166(p) YAS_PP_IIF(p(166), YAS_PP_NODE_165, YAS_PP_NODE_167)
#                            define YAS_PP_NODE_165(p) YAS_PP_IIF(p(165), 165, 166)
#                            define YAS_PP_NODE_167(p) YAS_PP_IIF(p(167), 167, 168)
#                    define YAS_PP_NODE_172(p) YAS_PP_IIF(p(172), YAS_PP_NODE_170, YAS_PP_NODE_174)
#                        define YAS_PP_NODE_170(p) YAS_PP_IIF(p(170), YAS_PP_NODE_169, YAS_PP_NODE_171)
#                            define YAS_PP_NODE_169(p) YAS_PP_IIF(p(169), 169, 170)
#                            define YAS_PP_NODE_171(p) YAS_PP_IIF(p(171), 171, 172)
#                        define YAS_PP_NODE_174(p) YAS_PP_IIF(p(174), YAS_PP_NODE_173, YAS_PP_NODE_175)
#                            define YAS_PP_NODE_173(p) YAS_PP_IIF(p(173), 173, 174)
#                            define YAS_PP_NODE_175(p) YAS_PP_IIF(p(175), 175, 176)
#                define YAS_PP_NODE_184(p) YAS_PP_IIF(p(184), YAS_PP_NODE_180, YAS_PP_NODE_188)
#                    define YAS_PP_NODE_180(p) YAS_PP_IIF(p(180), YAS_PP_NODE_178, YAS_PP_NODE_182)
#                        define YAS_PP_NODE_178(p) YAS_PP_IIF(p(178), YAS_PP_NODE_177, YAS_PP_NODE_179)
#                            define YAS_PP_NODE_177(p) YAS_PP_IIF(p(177), 177, 178)
#                            define YAS_PP_NODE_179(p) YAS_PP_IIF(p(179), 179, 180)
#                        define YAS_PP_NODE_182(p) YAS_PP_IIF(p(182), YAS_PP_NODE_181, YAS_PP_NODE_183)
#                            define YAS_PP_NODE_181(p) YAS_PP_IIF(p(181), 181, 182)
#                            define YAS_PP_NODE_183(p) YAS_PP_IIF(p(183), 183, 184)
#                    define YAS_PP_NODE_188(p) YAS_PP_IIF(p(188), YAS_PP_NODE_186, YAS_PP_NODE_190)
#                        define YAS_PP_NODE_186(p) YAS_PP_IIF(p(186), YAS_PP_NODE_185, YAS_PP_NODE_187)
#                            define YAS_PP_NODE_185(p) YAS_PP_IIF(p(185), 185, 186)
#                            define YAS_PP_NODE_187(p) YAS_PP_IIF(p(187), 187, 188)
#                        define YAS_PP_NODE_190(p) YAS_PP_IIF(p(190), YAS_PP_NODE_189, YAS_PP_NODE_191)
#                            define YAS_PP_NODE_189(p) YAS_PP_IIF(p(189), 189, 190)
#                            define YAS_PP_NODE_191(p) YAS_PP_IIF(p(191), 191, 192)
#        define YAS_PP_NODE_224(p) YAS_PP_IIF(p(224), YAS_PP_NODE_208, YAS_PP_NODE_240)
#            define YAS_PP_NODE_208(p) YAS_PP_IIF(p(208), YAS_PP_NODE_200, YAS_PP_NODE_216)
#                define YAS_PP_NODE_200(p) YAS_PP_IIF(p(200), YAS_PP_NODE_196, YAS_PP_NODE_204)
#                    define YAS_PP_NODE_196(p) YAS_PP_IIF(p(196), YAS_PP_NODE_194, YAS_PP_NODE_198)
#                        define YAS_PP_NODE_194(p) YAS_PP_IIF(p(194), YAS_PP_NODE_193, YAS_PP_NODE_195)
#                            define YAS_PP_NODE_193(p) YAS_PP_IIF(p(193), 193, 194)
#                            define YAS_PP_NODE_195(p) YAS_PP_IIF(p(195), 195, 196)
#                        define YAS_PP_NODE_198(p) YAS_PP_IIF(p(198), YAS_PP_NODE_197, YAS_PP_NODE_199)
#                            define YAS_PP_NODE_197(p) YAS_PP_IIF(p(197), 197, 198)
#                            define YAS_PP_NODE_199(p) YAS_PP_IIF(p(199), 199, 200)
#                    define YAS_PP_NODE_204(p) YAS_PP_IIF(p(204), YAS_PP_NODE_202, YAS_PP_NODE_206)
#                        define YAS_PP_NODE_202(p) YAS_PP_IIF(p(202), YAS_PP_NODE_201, YAS_PP_NODE_203)
#                            define YAS_PP_NODE_201(p) YAS_PP_IIF(p(201), 201, 202)
#                            define YAS_PP_NODE_203(p) YAS_PP_IIF(p(203), 203, 204)
#                        define YAS_PP_NODE_206(p) YAS_PP_IIF(p(206), YAS_PP_NODE_205, YAS_PP_NODE_207)
#                            define YAS_PP_NODE_205(p) YAS_PP_IIF(p(205), 205, 206)
#                            define YAS_PP_NODE_207(p) YAS_PP_IIF(p(207), 207, 208)
#                define YAS_PP_NODE_216(p) YAS_PP_IIF(p(216), YAS_PP_NODE_212, YAS_PP_NODE_220)
#                    define YAS_PP_NODE_212(p) YAS_PP_IIF(p(212), YAS_PP_NODE_210, YAS_PP_NODE_214)
#                        define YAS_PP_NODE_210(p) YAS_PP_IIF(p(210), YAS_PP_NODE_209, YAS_PP_NODE_211)
#                            define YAS_PP_NODE_209(p) YAS_PP_IIF(p(209), 209, 210)
#                            define YAS_PP_NODE_211(p) YAS_PP_IIF(p(211), 211, 212)
#                        define YAS_PP_NODE_214(p) YAS_PP_IIF(p(214), YAS_PP_NODE_213, YAS_PP_NODE_215)
#                            define YAS_PP_NODE_213(p) YAS_PP_IIF(p(213), 213, 214)
#                            define YAS_PP_NODE_215(p) YAS_PP_IIF(p(215), 215, 216)
#                    define YAS_PP_NODE_220(p) YAS_PP_IIF(p(220), YAS_PP_NODE_218, YAS_PP_NODE_222)
#                        define YAS_PP_NODE_218(p) YAS_PP_IIF(p(218), YAS_PP_NODE_217, YAS_PP_NODE_219)
#                            define YAS_PP_NODE_217(p) YAS_PP_IIF(p(217), 217, 218)
#                            define YAS_PP_NODE_219(p) YAS_PP_IIF(p(219), 219, 220)
#                        define YAS_PP_NODE_222(p) YAS_PP_IIF(p(222), YAS_PP_NODE_221, YAS_PP_NODE_223)
#                            define YAS_PP_NODE_221(p) YAS_PP_IIF(p(221), 221, 222)
#                            define YAS_PP_NODE_223(p) YAS_PP_IIF(p(223), 223, 224)
#            define YAS_PP_NODE_240(p) YAS_PP_IIF(p(240), YAS_PP_NODE_232, YAS_PP_NODE_248)
#                define YAS_PP_NODE_232(p) YAS_PP_IIF(p(232), YAS_PP_NODE_228, YAS_PP_NODE_236)
#                    define YAS_PP_NODE_228(p) YAS_PP_IIF(p(228), YAS_PP_NODE_226, YAS_PP_NODE_230)
#                        define YAS_PP_NODE_226(p) YAS_PP_IIF(p(226), YAS_PP_NODE_225, YAS_PP_NODE_227)
#                            define YAS_PP_NODE_225(p) YAS_PP_IIF(p(225), 225, 226)
#                            define YAS_PP_NODE_227(p) YAS_PP_IIF(p(227), 227, 228)
#                        define YAS_PP_NODE_230(p) YAS_PP_IIF(p(230), YAS_PP_NODE_229, YAS_PP_NODE_231)
#                            define YAS_PP_NODE_229(p) YAS_PP_IIF(p(229), 229, 230)
#                            define YAS_PP_NODE_231(p) YAS_PP_IIF(p(231), 231, 232)
#                    define YAS_PP_NODE_236(p) YAS_PP_IIF(p(236), YAS_PP_NODE_234, YAS_PP_NODE_238)
#                        define YAS_PP_NODE_234(p) YAS_PP_IIF(p(234), YAS_PP_NODE_233, YAS_PP_NODE_235)
#                            define YAS_PP_NODE_233(p) YAS_PP_IIF(p(233), 233, 234)
#                            define YAS_PP_NODE_235(p) YAS_PP_IIF(p(235), 235, 236)
#                        define YAS_PP_NODE_238(p) YAS_PP_IIF(p(238), YAS_PP_NODE_237, YAS_PP_NODE_239)
#                            define YAS_PP_NODE_237(p) YAS_PP_IIF(p(237), 237, 238)
#                            define YAS_PP_NODE_239(p) YAS_PP_IIF(p(239), 239, 240)
#                define YAS_PP_NODE_248(p) YAS_PP_IIF(p(248), YAS_PP_NODE_244, YAS_PP_NODE_252)
#                    define YAS_PP_NODE_244(p) YAS_PP_IIF(p(244), YAS_PP_NODE_242, YAS_PP_NODE_246)
#                        define YAS_PP_NODE_242(p) YAS_PP_IIF(p(242), YAS_PP_NODE_241, YAS_PP_NODE_243)
#                            define YAS_PP_NODE_241(p) YAS_PP_IIF(p(241), 241, 242)
#                            define YAS_PP_NODE_243(p) YAS_PP_IIF(p(243), 243, 244)
#                        define YAS_PP_NODE_246(p) YAS_PP_IIF(p(246), YAS_PP_NODE_245, YAS_PP_NODE_247)
#                            define YAS_PP_NODE_245(p) YAS_PP_IIF(p(245), 245, 246)
#                            define YAS_PP_NODE_247(p) YAS_PP_IIF(p(247), 247, 248)
#                    define YAS_PP_NODE_252(p) YAS_PP_IIF(p(252), YAS_PP_NODE_250, YAS_PP_NODE_254)
#                        define YAS_PP_NODE_250(p) YAS_PP_IIF(p(250), YAS_PP_NODE_249, YAS_PP_NODE_251)
#                            define YAS_PP_NODE_249(p) YAS_PP_IIF(p(249), 249, 250)
#                            define YAS_PP_NODE_251(p) YAS_PP_IIF(p(251), 251, 252)
#                        define YAS_PP_NODE_254(p) YAS_PP_IIF(p(254), YAS_PP_NODE_253, YAS_PP_NODE_255)
#                            define YAS_PP_NODE_253(p) YAS_PP_IIF(p(253), 253, 254)
#                            define YAS_PP_NODE_255(p) YAS_PP_IIF(p(255), 255, 256)
#
#endif // __yas__detail__preprocessor__auto_rec_hpp
